/*
	$Id: ScriptAnalyzer.java,v 1.1.1.1 2003/04/08 14:55:46 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
	̃NX͖{XbhZ[tłȂ̂ŁȂanalyze(Object)synchronized錾ĂB
*/

package core;
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class ScriptAnalyzer
{
    static final String[] percent_tags = {"%month","%day","%hour","%minute","%second","%username","%selfname2","%selfname","%keroname",
                                        "%ms","%mz","%ml","%mc","%mh","%mt","%me","%mp","%m?","%dms"};
    static Vector url_args;
    
    static NSColor tagcolor,errorcolor,varcolor,hontaicolor,unyuucolor,synchronizedcolor;
    static
    {
		tagcolor = NSColor.colorWithCalibratedRGB(0.0f,0.5f,0.0f,1.0f);
		errorcolor = NSColor.colorWithCalibratedRGB(0.9f,0.0f,0.0f,1.0f);
        varcolor = NSColor.colorWithCalibratedRGB(0.0f,0.0f,0.5f,1.0f);
		hontaicolor = NSColor.colorWithCalibratedRGB(0.831f,0.392f,0.0f,1.0f);
		unyuucolor = NSColor.colorWithCalibratedRGB(0.0f,0.470f,0.518f,1.0f);
		synchronizedcolor = NSColor.colorWithCalibratedRGB(0.8f,0.0f,0.667f,1.0f);
    }
    
    public static synchronized boolean analyze(Object source)
    {
        // source: NSTextNSMutableAttributedStringB
        // XNvg̓p[^ɃG[trueԂB
        if (!(source instanceof NSText) && !(source instanceof NSMutableAttributedString)) return true;
	
		// init
		lastColor = null;
		lastStartingPoint = 0;
        
        String data = (source instanceof NSText ? ((NSText)source).string() : ((NSAttributedString)source).stringReference().string());
        final int len = data.length();
        
        if (source instanceof NSText)
        {
			((NSView)source).setNeedsDisplay(false);
            ((NSText)source).setTextColorInRange(null,new NSRange(0,len));
        }
        else
        {
            ((NSMutableAttributedString)source).setAttributesInRange(null,new NSRange(0,len));
        }
        
        // obNXbVɒu
        if (data.indexOf('\\') != -1)
        {
            StringBuffer sb = new StringBuffer(data);
            
            int pos;
            while ((pos = sb.toString().indexOf('\\')) != -1)
            {
                sb.setCharAt(pos,'\u00a5');
            }
            
            data = sb.toString();
            
            if (source instanceof NSText)
            {
				NSRange savedrange = ((NSText)source).selectedRange();
                ((NSText)source).setString(data);
				((NSText)source).setSelectedRange(savedrange);
            }
            else
            {
                ((NSMutableAttributedString)source).replaceCharactersInRange(new NSRange(0,data.length()),data);
            }
        }
	
		boolean hontaiContext = true; // {̂ɃtH[JXĂ鎞trueɂȂ܂B
		boolean synchronizedContext = false; // VNiCYhZbVBꂪtrue̎hontaiContext͖܂B
        
        int pos = 0;
        boolean error = false;
        while (pos < len)
        {
            if (pos == len - 1) // Ō̕
            {
                // ʏ핶̂݋
                if (data.charAt(pos) == '\u00a5' || data.charAt(pos) == '\\' || data.charAt(pos) == '%')
                {
                    // ERROR
                    setColor(source,errorcolor,pos,1);
                    error = true;
                    pos++;
                }
				else
				{
					if (synchronizedContext)
					{
						setColor(source,synchronizedcolor,pos,1);
					}
					else
					{
						setColor(source,(hontaiContext ? hontaicolor : unyuucolor),pos,1);
					}
				}
                break;
            }
            
            switch (data.charAt(pos))
            {
                case	'\u00a5': // 
                case	'\\':
                if ("thuenc".indexOf(data.charAt(pos+1)) != -1) // ̓p[^Ȃ
                {
                    // 񂢁[̌͑̕SăG[B
                    if (data.charAt(pos+1) == 'e' && pos+1 != len-1)
                    {
                        // ȏ񕶎tagcolorɂB
                        setColor(source,tagcolor,pos,2);
                        // ERROR
                        setColor(source,errorcolor,pos+2,len - (pos+2));
                        error = true;
                        pos = len;
                    }
                    else
                    {
						if (data.charAt(pos+1) == 'h')
						{
							hontaiContext = true;
						}
						else if (data.charAt(pos+1) == 'u')
						{
							hontaiContext = false;
						}
			
                        // ȏ񕶎tagcolorɂB
                        // OK
                        setColor(source,tagcolor,pos,2);
                        pos += 2;
                    }
                }
                else if (data.charAt(pos+1) == 'w') // ͐ꕶ
                {
                    if (pos + 1 == len - 1) // \wŏIĂ
                    {
                        // ERROR
                        setColor(source,errorcolor,pos,2);
                        error = true;
                        pos += 2;
                    }
                    else
                    {
                        if (Character.isDigit(data.charAt(pos+2)))
                        {
                            // OK
                            setColor(source,tagcolor,pos,3);
                            pos += 3;
                        }
                        else
                        {
                            // ERROR
                            setColor(source,errorcolor,pos,3);
                            error = true;
                            pos += 3;
                        }
                    }
                }
				else if (data.charAt(pos+1) == '_') // \_sy\_q̂݋B
				{
					if (pos + 1 == len - 1) // \_ŏIĂ
                    {
                        // ERROR
                        setColor(source,errorcolor,pos,2);
                        error = true;
                        pos += 2;
                    }
					else if (data.charAt(pos+2) == 's') // \_s^OBB
					{
						synchronizedContext = !synchronizedContext;
						// OK
						setColor(source,tagcolor,pos,3);
						pos += 3;
					}
					else if (data.charAt(pos+2) == 'q') // \_q^OBB
					{
						// OK
						setColor(source,tagcolor,pos,3);
						pos += 3;
					}
					else // ȊO\_^O͕s
					{
						// ERROR
						setColor(source,errorcolor,pos,3);
						error = true;
						pos += 3;
					}
				}
				else if (data.charAt(pos+1) == 'U') // \URL̂݋BԕGB
				{
					if (pos + 1 == len - 1) // \UŏIĂ
					{
						// ERROR
                        setColor(source,errorcolor,pos,2);
                        error = true;
                        pos += 2;
                    }
					else if (data.startsWith("\u00a5URL[",pos)) // \URL[܂ŊmF
					{
						// [...][...]̑gݍ킹zɓĂB
						if (url_args == null)
						{
							url_args = new Vector();
						}
						else
						{
							url_args.clear();
						}
						int blockstart = pos+4;
						int blockend;
						while (true)
						{
							blockend = blockstart; // ̈ꕶォ猟
							while (true)
							{
								blockend = data.indexOf(']',blockend+1);
								if (blockend == -1) break;
								if (data.charAt(blockend-1) != '\u00a5') break; // GXP[vĂxB
							}
							if (blockend == -1) // ܂茩Ȃ
							{
								break; // I
							}
							else
							{
								url_args.add(data.substring(blockstart+1,blockend));
								blockstart = blockend + 1;
								if (len <= blockstart || data.charAt(blockstart) != '[') break; // ォĂюn܂ĂȂΏIB
							}
						}
						if (blockend == -1) // ʂĂȂꍇB
						{
							setColor(source,errorcolor,pos,len - pos); // c̃XNvgŚB
							error = true;
							pos = len;
						}
						else if (url_args.size() <= 0 || url_args.size() % 2 == 0) // ł͂ȂB
						{
							// ERROR
							setColor(source,errorcolor,pos,blockend - pos + 1); // Ō̕ʂ܂ŁB
							error = true;
							pos = blockend+1;
						}
						else if (url_args.size() == 1) // ꍇ͂URL`FbNB
						{
							String arg = (String)url_args.elementAt(0);
							if (arg.startsWith("http://"))
							{
								// OK
								setColor(source,tagcolor,pos,blockend - pos + 1); // Ō̕ʂ܂ŁB
								pos = blockend+1;
							}
							else
							{
								// ERROR
								setColor(source,errorcolor,pos,blockend - pos + 1); // Ō̕ʂ܂ŁB
								error = true;
								pos = blockend+1;
							}
						}
						else // ΋Ԗڂ̂URL`FbNB
						{
							int n_args = url_args.size();
							boolean good = true;
							for (int i = 2;i <= n_args;i += 2)
							{
								String arg = (String)url_args.elementAt(i-1);
								if (!arg.startsWith("http://"))
								{
									// BAD
									good = false;
								}
							}
							if (good)
							{
								// OK
								setColor(source,tagcolor,pos,blockend - pos + 1); // Ō̕ʂ܂ŁB
								pos = blockend+1;
							}
							else
							{
								// ERROR
								setColor(source,errorcolor,pos,blockend - pos + 1); // Ō̕ʂ܂ŁB
								error = true;
								pos = blockend+1;
							}
						}
					}
					else
					{
						// ERROR
                        setColor(source,errorcolor,pos,2);
                        error = true;
                        pos += 2;
					}
				}
                else if (data.charAt(pos+1) == 's') // ͐ꕶ[]Ɉ͂܂ꂽ̃̕p[^
                {
                    if (pos + 1 == len - 1) // \sŏIĂ
                    {
                        // ERROR
                        setColor(source,errorcolor,pos,2);
                        error = true;
                        pos += 2;
                    }
                    else
                    {
                        char thirdchar = data.charAt(pos+2);
                        if (Character.isDigit(thirdchar))
                        {
                            // OK
							setColor(source,tagcolor,pos,3);
							pos += 3;
                        }
                        else if (thirdchar == '[')
                        {
                            // ʂ܂ł͑̕SĐłȂ΂ȂȂB
                            // ܂A0820,25,10,11,19̂݁B
                            int blockend = data.indexOf(']',pos+2);
                            if (blockend == -1)
                            {
                                // ERROR
                                setColor(source,errorcolor,pos,len - pos);
                                error = true;
                                pos = len;
                            }
                            else if (blockend == pos+2) // []ɂȂĂB
                            {
                                // ERROR
                                setColor(source,errorcolor,pos,4);
                                error = true;
                                pos += 4;
                            }
                            else
                            {
                                try
                                {
                                    int param = Integer.parseInt( data.substring(pos+3,blockend) );
									if (param >= 0 || param == -1)
                                    {
										// OK
                                        setColor(source,tagcolor,pos,blockend - pos + 1);
                                        pos = blockend + 1;
                                    }
                                    else
                                    {
                                        // ERROR
                                        setColor(source,errorcolor,pos,blockend - pos + 1);
                                    	error = true;
                                        pos = blockend + 1;
                                    }
                                }
                                catch (Exception e)
                                {
                                    // ERROR
                                    setColor(source,errorcolor,pos,blockend - pos + 1);
                                    error = true;
                                    pos = blockend + 1;
                                }
                            }
                        }
                        else // ł[łł%łȂ
                        {
                            // ERROR
                            setColor(source,errorcolor,pos,3);
                            error = true;
                            pos += 3;
                        }
                    }
                }
                else if (data.charAt(pos+1) == '\u00a5' || data.charAt(pos+1) == '\\' || data.charAt(pos+1) == '%') // GXP[v
                {
                    // OK
					setColor(source,(hontaiContext ? hontaicolor : unyuucolor),pos,2);
                    pos += 2;
                }
                else // `͋֎~^O
                {
                    // ERROR
                    setColor(source,errorcolor,pos,2);
                    error = true;
                    pos += 2;
                }
                break;
                
                case	'%':
                boolean found = false;
                for (int i = 0;i < percent_tags.length;i++)
                {
                    if (data.startsWith(percent_tags[i],pos))
                    {
                        // OK
                        found = true;
                        setColor(source,varcolor,pos,percent_tags[i].length());
                        pos += percent_tags[i].length();
                        break;
                    }
                }
                if (!found)
                {
                    /*
					// ERROR
                    setColor(source,errorcolor,pos,1);
                    error = true;
                    pos++;
					*/
					if (synchronizedContext) {
						setColor(source,synchronizedcolor,pos,1);
					}
					else {
						setColor(source,(hontaiContext ? hontaicolor : unyuucolor),pos,1);
					}
					pos++;
                }
                break;
                
                default:
				if (synchronizedContext)
				{
					setColor(source,synchronizedcolor,pos,1);
				}
				else
				{
					setColor(source,(hontaiContext ? hontaicolor : unyuucolor),pos,1);
				}
                pos++;
            }
        }
	
		// clean-up
		setColor(source,null,len,0);
	
		if (source instanceof NSText)
        {
			((NSView)source).setNeedsDisplay(true);
        }
	
        return error;
    }
    
    private static NSColor lastColor = null;
    private static int lastStartingPoint = 0;
    private static void setColor(Object source,NSColor color,int pos,int len)
    {
		// color == null̏ꍇ̓N[Abvs܂B
		// ̍posɂ͕Kw肵ĉB
		
		// ̃\bh͐擪V[PVɎgpȂ΂Ȃ܂B
		// Cӂ̏ꏊɐFw肷邱Ƃ͏o܂B
		
		// gpOɕKlastColorlastStartingPointĉB
		
		if (color == lastColor)
		{
			return;
		}
		else
		{
			// ܂lastStartingPoint͈͂̒O܂łlastColorɃZbg
			if (lastColor != null)
			{
				try {
					NSRange range = new NSRange(lastStartingPoint,(pos-1) - lastStartingPoint + 1);
					if (source instanceof NSText)
					{
						((NSText)source).setTextColorInRange(lastColor,range);
					}
					else
					{
						((NSMutableAttributedString)source).addAttributeInRange(NSAttributedString.ForegroundColorAttributeName,lastColor,range);
					}
				}
				catch (Exception e) {}
			}
			
			// eϐZbg
			lastColor = color;
			lastStartingPoint = pos;
		}
    }
    
    public static String expandYenURL(String script)
    {
		// \URL^OWJ܂B
		// @G[ƂOɏ܂BsȂ\analyze()Ń`FbNĂĉB
		int n_enq_exists = 0;
		
		StringBuffer buf = new StringBuffer(script);
		int pos;
		while ((pos = buf.toString().indexOf('\\')) != -1)
		{
			buf.setCharAt(pos,'\u00a5');
		}
	
		pos = 0;
		while (pos < buf.length())
		{
			pos = buf.toString().indexOf("\u00a5URL",pos);
			if (pos == -1) break; // end
			if (pos >= 1 && buf.charAt(pos-1) == '\u00a5') {pos++; continue;} // escaped ({\\lׂdd)
			
			Vector args = new Vector();
			int blockstart = pos+4;
			int blockend;
			while (true)
			{
				blockend = blockstart; // ̈ꕶォ猟
				while (true)
				{
					blockend = buf.toString().indexOf(']',blockend+1);
					if (buf.charAt(blockend-1) != '\u00a5') break; // GXP[vĂxB
				}
				args.add(buf.substring(blockstart+1,blockend));
				blockstart = blockend + 1;
				if (buf.length() <= blockstart || buf.charAt(blockstart) != '[') break; // ォĂюn܂ĂȂΏIB
			}
			if (args.size() == 1) // YES/NO style
			{
				buf.replace(
					pos,blockend+1,
					"\u00a5q"+n_enq_exists+'['+(String)args.elementAt(0)+"][Go]" +
					"\u00a5q"+(n_enq_exists+1)+"[][Cancel]"
					);
				n_enq_exists += 2;
			}
			else // TABLE style
			{
				// LZ͍ŌɎĂB
				StringBuffer enqtags = new StringBuffer();
				final int n_args = args.size();
				for (int i = 1;i < n_args;i += 2)
				{
					String url = (String)args.elementAt(i);
					String label = (String)args.elementAt(i+1);
					
					enqtags.append("\u00a5q"+n_enq_exists+'['+url+"]["+label+']');
					n_enq_exists++;
				}
				enqtags.append("\u00a5q"+n_enq_exists+"[]["+(String)args.elementAt(0)+']');
				n_enq_exists++; // 
				
				buf.replace(pos,blockend+1,enqtags.toString());
			}
		}
		return buf.toString();
    }
}
