/*
	$Id: LogDownloadController.java,v 1.1.1.1 2003/04/08 14:55:46 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui.logdownload;
import gui.logdownload.*;
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class LogDownloadController extends NSWindowController
{
	protected static LogDownloadController _shared_instance = null;

    public NSTextField day; /* IBOutlet */
    public NSButton get_button; /* IBOutlet */
    public NSTextField info; /* IBOutlet */
    public NSTextField month; /* IBOutlet */
    public NSProgressIndicator progress; /* IBOutlet */
    public NSTextField year; /* IBOutlet */
	
	Downloader downloader = null;
	
	public static LogDownloadController sharedController()
	{
		if (_shared_instance == null) {
			_shared_instance = new LogDownloadController();
		}
		return _shared_instance;
	}
	
	protected LogDownloadController()
	{
		super("LogDownload");
		loadWindow();
		
		window().setFrameUsingName("logdownload.frame");
        window().setFrameAutosaveName("logdownload.frame");
		
		//progress.setUsesThreadedAnimation(true);
		progress.setIndeterminate(false);
		progress.setMinValue(0);
		progress.setMaxValue(1);
		progress.setDoubleValue(0);
	}
	
	public void showWindow(Object sender)
	{
		// ̓tݒB
		Calendar cal = Calendar.getInstance();
		year.setIntValue(cal.get(Calendar.YEAR));
		month.setIntValue(cal.get(Calendar.MONTH)+1);
		day.setIntValue(cal.get(Calendar.DAY_OF_MONTH));
		
		super.showWindow(sender);
	}

    public void getLog(Object sender)
	{
		if (downloader == null || !downloader.isAlive()) {
			try {
				int int_year = Integer.parseInt(year.stringValue());
				int int_month = Integer.parseInt(month.stringValue());
				int int_day = Integer.parseInt(day.stringValue());
				
				downloader = new Downloader(this,int_year,int_month,int_day);
				downloader.start();
			}
			catch (NumberFormatException e) {
				info.setStringValue("error: not a valid date.");
			}
		}
    }
	
	public void setEnabledGetButton(boolean bool)
	{
		get_button.setEnabled(bool);
	}
	
	public void setMessage(String msg)
	{
		info.setStringValue(msg);
	}
	
	public void setProgressState(double val)
	{
		// 0  val  1͈̔͂ŎwB
		// -1w肵ꍇ́A͈͖Aj[V
		if (val == -1) {
			progress.setIndeterminate(true);
			progress.startAnimation(this);
		}
		else {
			progress.setIndeterminate(false);
			progress.stopAnimation(this);
			progress.setDoubleValue(val);
		}
	}
}
