/*
	$Id: PrefWindowController.java,v 1.1.1.1 2003/04/08 14:55:46 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui.pref;
import gui.pref.*;
import core.*;
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;

public class PrefWindowController extends NSWindowController
{
    private static PrefWindowController _sharedInstance = null;
    
    NSButton check_playsound;
    NSPopUpButton listbutton_sounds;
    NSButton button_playsound;
    
    NSTextField botserver_server;
    NSTextField botserver_slppport;
    NSTextField botserver_httpport;
    
    NSTextField sstpserver_server;
    NSTextField sstpserver_sstpport;
    
    NSTextField iniscript_script;
	
	NSButton proxy_use_proxy;
	NSTextField proxy_http_proxy_host;
	NSTextField proxy_http_proxy_port;
    
    NSTableView ghostspec_table;
    PrefGhostSpecTableDataSource ghostspec_table_datasource; // Not an IBOutlet!
    NSButton ghostspec_remove;
    
    public static PrefWindowController sharedPrefWindowController()
    {
		if (_sharedInstance == null)
		{
			_sharedInstance = new PrefWindowController();
		}
		return _sharedInstance;
    }
    
    public PrefWindowController()
    {
		super("Pref");
		loadWindow();
		
		// CXg[ĂTEht@CăXg\
		listbutton_sounds.removeAllItems();
		NSArray libraries = NSPathUtilities.searchPathForDirectoriesInDomains(
				NSPathUtilities.LibraryDirectory,
				NSPathUtilities.LocalDomainMask + NSPathUtilities.SystemDomainMask + NSPathUtilities.UserDomainMask,
				true);
		int n_libraries = libraries.count();
		for (int i = 0;i < n_libraries;i++)
		{
			File sounddir = new File((String)libraries.objectAtIndex(i),"Sounds");
			if (!sounddir.exists() || !sounddir.isDirectory()) continue;
			
			File[] files = sounddir.listFiles();
			for (int j = 0;j < files.length;j++)
			{
				// gq蕥̂TEhB
				String soundname = NSPathUtilities.stringByDeletingPathExtension(files[j].getName());
				listbutton_sounds.addItem(soundname);
			}
		}
	
		// ݒ肳ĂTEh\
		NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
		String soundname = (String)defaults.objectForKey("sound_bottle_receive name");
		if (soundname != null) listbutton_sounds.selectItemWithTitle(soundname);
		
		// enable/disable
		check_playsound.setIntValue(defaults.integerForKey("sound_bottle_receive enabled"));
		check_playsound(check_playsound); // ԍXV
		
		// bottle server
		String botservername = (String)defaults.objectForKey("bottleserver.servername");
		botserver_server.setStringValue(botservername == null ? "bottle.mikage.to" : botservername);
		int slppport = defaults.integerForKey("bottleserver.slppport");
		botserver_slppport.setIntValue(slppport == 0 ? 9871 : slppport);
		int httpport = defaults.integerForKey("bottleserver.httpport");
		botserver_httpport.setIntValue(httpport == 0 ? 80 : httpport);
		
		// sstp server
		String sstpservername = (String)defaults.objectForKey("sstpserver.servername");
		sstpserver_server.setStringValue(sstpservername == null ? "localhost" : sstpservername);
		int sstpport = defaults.integerForKey("sstpserver.sstpport");
		sstpserver_sstpport.setIntValue(sstpport == 0 ? 11000 : sstpport);
		
		// initial script
		String initialscript = (String)defaults.objectForKey("iniscript.script");
		iniscript_script.setStringValue(initialscript == null ? "\u00a5t\u00a5u\u00a5s[10]\u00a5h\u00a5s[0]|\u00a5e" : initialscript);
		
		// proxy
		proxy_use_proxy.setIntValue(defaults.integerForKey("proxy.http.use"));
		String http_proxy_host = (String)defaults.objectForKey("proxy.http.host");
		proxy_http_proxy_host.setStringValue(http_proxy_host == null ? "" : http_proxy_host);
		proxy_http_proxy_port.setIntValue(defaults.integerForKey("proxy.http.port"));
		
		// ghost spec
		ghostspec_table_datasource = new PrefGhostSpecTableDataSource();
		NSArray ghostspec_array = defaults.arrayForKey("ghostspec.table");
		if (ghostspec_array == null)
		{
			ghostspec_table_datasource.setArray(createDefaultGhostNamesArray());
		}
		else
		{
			ghostspec_table_datasource.setArray(newVectorFromNSArray(ghostspec_array));
		}
        ghostspec_table.setDataSource(ghostspec_table_datasource);
		ghostspec_table.setDelegate(this);
		updateGhostSpecControlsState();
    }
	
	public static NSArray newNSArrayFromVector(Vector vec)
	{
		final int size_vec = vec.size();
		NSMutableArray array = new NSMutableArray(); // TCY̐ݒ肪oȂI
		for (int i = 0; i < size_vec; i++) {
			array.addObject(vec.elementAt(i));
		}
		return array;
	}
	
	public static Vector newVectorFromNSArray(NSArray array)
    {
		final int size_array = array.count();
		Vector vec = new Vector(size_array);
		for (int i = 0; i < size_array; i++) {
			vec.add(array.objectAtIndex(i));
		}
		return vec;
    }
    
    public static Vector createDefaultGhostNamesArray()
    {
		Vector array = new Vector();
		array.add("\u3055\u304f\u3089"); // 
		array.add("\u53cc\u8449"); // ot
		array.add("\u305b\u308a\u3053"); // 肱
		array.add("\u7406\u5922"); // 
		array.add("\u307e\u3086\u3089"); // ܂
		array.add("\u306d\u3053\u3053"); // ˂
		array.add("\u3064\u3050\u306a"); // 
		array.add("\u82b1\u3061\u3083\u3093"); // Ԃ
		array.add("\u5b89\u5b50\u3055\u3093"); // q
		array.add("\u7f8e\u8033"); // 
		array.add("\u307f\u304b\u3093"); // ݂
		array.add("\u3088\u308f\u306d"); // 
		return array;
    }
    
    public void updateGhostSpecControlsState()
    {
		boolean selectedOne = (ghostspec_table.selectedRow() != -1);
		ghostspec_remove.setEnabled(selectedOne);
    }
    
    /******** delegate methods ********/
    public boolean windowShouldClose(Object sender)
    {
		NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
        // defaultsɕۑ܂B
	
		// sound
		String selectedTitle = listbutton_sounds.titleOfSelectedItem();
		defaults.setObjectForKey(selectedTitle,"sound_bottle_receive name");
		defaults.setIntegerForKey(check_playsound.intValue(),"sound_bottle_receive enabled");
		
		// bottle server
		defaults.setObjectForKey(botserver_server.stringValue(),"bottleserver.servername");
		defaults.setIntegerForKey(botserver_slppport.intValue(),"bottleserver.slppport");
		defaults.setIntegerForKey(botserver_httpport.intValue(),"bottleserver.httpport");
		
		// sstp server
		defaults.setObjectForKey(sstpserver_server.stringValue(),"sstpserver.servername");
		defaults.setIntegerForKey(sstpserver_sstpport.intValue(),"sstpserver.sstpport");
		
		// initial script
		defaults.setObjectForKey(iniscript_script.stringValue(),"iniscript.script");
		
		// proxy
		defaults.setIntegerForKey(proxy_use_proxy.intValue(),"proxy.http.use");
		defaults.setObjectForKey(proxy_http_proxy_host.stringValue(),"proxy.http.host");
		defaults.setIntegerForKey(proxy_http_proxy_port.intValue(),"proxy.http.port");
		
		// ghost spec
		defaults.setObjectForKey(newNSArrayFromVector(ghostspec_table_datasource.getArray()),"ghostspec.table");
		NSNotificationCenter.defaultCenter().postNotification("BCGhostSpecModified",this);
		
		defaults.synchronize();
		return true; // allow closing
    }
    
    public void tableViewSelectionDidChange(NSNotification aNotification)
    {
		// ghostspec_tableȊO͍lȂB
		updateGhostSpecControlsState();
    }
    
    /********* action methods *********/
    public void check_playsound(Object sender)
    {
		boolean enabled = (check_playsound.intValue() == 1);
		listbutton_sounds.setEnabled(enabled);
		button_playsound.setEnabled(enabled);
		Foundation.sharedFoundation().setEnabledOfSoundOfReceiveBottle(enabled);
    }

    public void listbutton_sounds(Object sender)
    {
		Foundation foundation = Foundation.sharedFoundation();
		
		foundation.setSoundOfReceivingBottle(listbutton_sounds.titleOfSelectedItem());
		foundation.playSoundOfReceiveBottle();
    }
    
    public void playsound(Object sender)
    {
		Foundation.sharedFoundation().playSoundOfReceiveBottle();
    }
    
    public void botserver_reset(Object sender)
    {
		botserver_server.setStringValue("bottle.mikage.to");
		botserver_slppport.setIntValue(9871);
		botserver_httpport.setIntValue(80);
    }
    
    public void sstpserver_reset(Object sender)
    {
		sstpserver_server.setStringValue("localhost");
		sstpserver_sstpport.setIntValue(11000);
    }
    
    public void iniscript_reset(Object sender)
    {
		iniscript_script.setStringValue("\u00a5t\u00a5u\u00a5s[10]\u00a5h\u00a5s[0]|\u00a5e");
    }
    
    public void ghostspec_reset(Object sender)
    {
		ghostspec_table_datasource.setArray(createDefaultGhostNamesArray());
		ghostspec_table.reloadData();
    }
    
    public void ghostspec_add(Object sender)
    {
		ghostspec_table_datasource.addItem();
		ghostspec_table.reloadData();
	
		// Ō̍ڂIҏWԂɂ
		int last_row_index = ghostspec_table.numberOfRows()-1;
		ghostspec_table.selectRow(last_row_index,false); // ̂ȂƃG[ɂȂB
		ghostspec_table.editLocation(0,last_row_index,null,true);
    }
    
    public void ghostspec_remove(Object sender)
    {
		ghostspec_table_datasource.removeItemAtIndex(ghostspec_table.selectedRow());
		ghostspec_table.reloadData();
    }
}
