/*
	$Id: YenURLAssistantTableStyleView.java,v 1.1.1.1 2003/04/08 14:55:46 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui.yenurl;
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class YenURLAssistantTableStyleView extends NSView implements YenURLAssistantController.YenURLAssistantSubview
{
    NSButton btn_add;
    NSButton btn_remove;
    NSButton btn_up;
    NSButton btn_down;
    NSTextField fld_cancel;
    NSTableView table;
    
    YenURLAssistantURLTableContent tableContent;
    
    public YenURLAssistantTableStyleView(NSRect r)
    {
        super(r);
    }
    
    public void add(Object sender)
    {
		tableContent.addElement();
    }
    
    public void remove(Object sender)
    {
		tableContent.removeSelectedElement();
    }
    
    public void up(Object sender)
    {
		tableContent.moveUpSelection();
    }
    
    public void down(Object sender)
    {
		tableContent.moveDownSelection();
    }
    
    public void setup()
    {
		tableContent = new YenURLAssistantURLTableContent(this,table);
		table.setDataSource(tableContent);
    }
    
    public String generateYenURLTag()
    {
		return "\u00a5URL["+fld_cancel.stringValue()+']'+tableContent.generateTablePartOfYenURLTag();
    }
    
    public void resetAll()
    {
		fld_cancel.setStringValue("");
		tableContent.removeAll();
    }
    
    public void validate()
    {
		boolean allGreen = true;
		if (fld_cancel.stringValue().length() == 0) allGreen = false;
		if (table.numberOfRows() == 0) allGreen = false;
		if (!tableContent.checkIfAllGreen()) allGreen = false;
		
		YenURLAssistantController.sharedController().setEnabledOfEnterButton(allGreen);
    }
    
    // delegate
    public void controlTextDidChange(NSNotification aNotification) // ignores aNotification
    {
		validate();
    }
}
