/*
	$Id: Httpd.java,v 1.1.1.1 2003/04/08 14:55:47 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2003 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package log.logviewer;
import log.*;
import log.logviewer.*;
import java.net.*;
import java.io.*;
import com.apple.cocoa.foundation.*;

public class Httpd extends Thread
{
	int port;
	ServerSocket ss;
	
	public static final String resource_path = NSBundle.mainBundle().resourcePath();
	public static final TextTemplatePackage tmpl_index;
	static {
		tmpl_index = new TextTemplatePackage(
			new File(resource_path,"logviewer-tmpl/index.html"),"UTF-8");
	}
	
	public static final String css_default;
	static {
		css_default = read_file(
			new File(resource_path,"logviewer-tmpl/css/default.css"),"UTF-8");
	}
	
	public Httpd(int port)
	{
		this.port = port;
	}
	
	public void run()
	{
		try {
			ss = new ServerSocket(port);
			
			while (true) {
				try {
					Socket s = ss.accept();
					
					// [J[vobN̐ڑłȂΏRB
					if (s.getInetAddress().getHostAddress().equals("127.0.0.1")) {
						new HttpSession(s).start();
					}
					else {
						s.close();
					}
				}
				catch (Exception ex) {
					System.err.println(ex.toString());
					ex.printStackTrace();
				}
			}
		}
		catch (Exception e) {
			//System.err.println(e.toString());
			e.printStackTrace();
		}
	}
	
	public static String read_file(File f,String encoding)
	{
		StringBuffer result = new StringBuffer();
		
		try {
			BufferedReader br = new BufferedReader(
				new InputStreamReader(
					new FileInputStream(f),encoding));
			while (true) {
				String line = br.readLine();
				if (line == null) {
					break;
				}
				
				result.append(line).append("\n");
			}
		}
		catch (Exception e) {
			System.err.println("Couldn't read file "+f.getPath());
			e.printStackTrace();
		}
		
		return result.toString();
	}
}
